

MchaleHandler = {};

function MchaleHandler.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Attachable, specializations);
end;

function MchaleHandler:load(xmlFile)	

	self.setFork = SpecializationUtil.callSpecializationsFunction("setFork");
	self.setBale = SpecializationUtil.callSpecializationsFunction("setBale");
	self.objectInRange = MchaleHandler.objectInRange;

	self.fork1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.forks#index1"));
	self.fork2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.forks#index2"));
	self.fork3 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.forks#index3"));
	self.fork4 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.forks#index4"));
	self.forkId = 0;
	
	self.node1 = {};
	self.node2 = {};
	self.node3 = {};
	self.node1.node = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.locknode#index1"));
	self.node2.node = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.locknode#index2"));
	self.node3.node = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.locknode#index3"));
	self.node1.baleId = nil;
	self.node2.baleId = nil;
	self.node3.baleId = nil;
	self.lock = {};
	self.lock.node = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.locknode#index1"));
	self.lock.child = getChildAt(self.lock.node, 0);
	self.lock.baleId = nil;
	self.isClosed = false;

	local Rot1Node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.Rot1#index"));
    if Rot1Node ~= nil then
        self.Rot1 = {};
        self.Rot1.node = Rot1Node;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.Rot1#minRot"));
        self.Rot1.minRot = {};
        self.Rot1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.Rot1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.Rot1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.Rot1#maxRot"));
        self.Rot1.maxRot = {};
        self.Rot1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.Rot1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.Rot1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.Rot1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.Rot1#rotTime"), 2)*1000;
    end;
	local Rot2Node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.Rot2#index"));
    if Rot2Node ~= nil then
        self.Rot2 = {};
        self.Rot2.node = Rot2Node;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.Rot2#minRot"));
        self.Rot2.minRot = {};
        self.Rot2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.Rot2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.Rot2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.Rot2#maxRot"));
        self.Rot2.maxRot = {};
        self.Rot2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.Rot2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.Rot2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.Rot2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.Rot2#rotTime"), 2)*1000;
    end;
	local Rot3Node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.Rot3#index"));
    if Rot3Node ~= nil then
        self.Rot3 = {};
        self.Rot3.node = Rot3Node;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.Rot3#minRot"));
        self.Rot3.minRot = {};
        self.Rot3.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.Rot3.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.Rot3.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.Rot3#maxRot"));
        self.Rot3.maxRot = {};
        self.Rot3.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.Rot3.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.Rot3.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.Rot3.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.Rot3#rotTime"), 2)*1000;
    end;
	local Rot4Node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.Rot4#index"));
    if Rot4Node ~= nil then
        self.Rot4 = {};
        self.Rot4.node = Rot4Node;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.Rot4#minRot"));
        self.Rot4.minRot = {};
        self.Rot4.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.Rot4.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.Rot4.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.Rot4#maxRot"));
        self.Rot4.maxRot = {};
        self.Rot4.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.Rot4.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.Rot4.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.Rot4.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.Rot4#rotTime"), 2)*1000;
    end;
	local Rot5Node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.Rot5#index"));
    if Rot5Node ~= nil then
        self.Rot5 = {};
        self.Rot5.node = Rot5Node;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.Rot5#minRot"));
        self.Rot5.minRot = {};
        self.Rot5.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.Rot5.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.Rot5.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.Rot5#maxRot"));
        self.Rot5.maxRot = {};
        self.Rot5.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.Rot5.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.Rot5.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.Rot5.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.Rot5#rotTime"), 2)*1000;
    end;
	local Rot6Node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.Rot6#index"));
    if Rot6Node ~= nil then
        self.Rot6 = {};
        self.Rot6.node = Rot6Node;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.Rot6#minRot"));
        self.Rot6.minRot = {};
        self.Rot6.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.Rot6.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.Rot6.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.Rot6#maxRot"));
        self.Rot6.maxRot = {};
        self.Rot6.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.Rot6.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.Rot6.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.Rot6.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.Rot6#rotTime"), 2)*1000;
    end;

	
	self.keys = {};
	self.keysDesc = {};
    local i=0;
    while true do
        local baseName = string.format("vehicle.keys.input(%d)", i);
       local inputName = getXMLString(xmlFile, baseName.. "#name");
        if inputName == nil then
            break;
        end;
        local inputKey = getXMLString(xmlFile, baseName.. "#key");
        if Input[inputKey] == nil then
            print("Error: invalid key '" .. inputKey .. "'  for input event '" .. inputName .. "'");
            break;
       end;
        self.keys[inputName] = Input[inputKey];
		self.keysDesc[inputName] = getXMLString(xmlFile, baseName.. "#keyDesc");
        i = i+1;
    end;

hydraOpenSoundFile = Utils.getFilename("hydraopen.wav", self.baseDirectory);
    self.hydraOpenSoundId = createSample("HYDOPEN_hydraOpen");
    loadSample(self.hydraOpenSoundId, hydraOpenSoundFile, false);
    self.hydraOpenPlaying = false;

hydraCloseSoundFile = Utils.getFilename("hydraclose.wav", self.baseDirectory);
    self.hydraCloseSoundId = createSample("HYDCLOSE_hydraClose");
    loadSample(self.hydraCloseSoundId, hydraCloseSoundFile, false);
    self.hydraClosePlaying = false;
	
end;

function MchaleHandler:delete()
	self:setBale(nil, false);
end;

function MchaleHandler:onDetach()
	self:setBale(nil, false);
end;

function MchaleHandler:readStream(streamId, connection)
	self:setFork(streamReadInt8(streamId), true);
	self:setBale(streamReadInt32(streamId), true);
end;

function MchaleHandler:writeStream(streamId, connection)
	streamWriteInt8(streamId, self.forkId);
	streamWriteInt32(streamId, self.lock.baleId);
end;

function MchaleHandler:mouseEvent(posX, posY, isDown, isUp, button)
end;

function MchaleHandler:keyEvent(unicode, sym, modifier, isDown)
end;

function MchaleHandler:update(dt)
	
	if self:getIsActive() then
		if self:getIsActiveForInput() then	
			
			if Input.isKeyPressed(self.keys.OPEN_PLIERS) and self.node1.baleId == nil then
				local x, y, z = getRotation(self.Rot1.node);
		        local rot = {x,y,z};
		        local newRot = Utils.getMovedLimitedValues(rot, self.Rot1.maxRot, self.Rot1.minRot, 3, self.Rot1.rotTime*2, dt, true);
			    setRotation(self.Rot1.node, unpack(newRot));
				local x, y, z = getRotation(self.Rot2.node);
		        local rot = {x,y,z};
		        local newRot = Utils.getMovedLimitedValues(rot, self.Rot2.maxRot, self.Rot2.minRot, 3, self.Rot2.rotTime*2, dt, true);
			    setRotation(self.Rot2.node, unpack(newRot));
				local x, y, z = getRotation(self.Rot3.node);
		        local rot = {x,y,z};
		        local newRot = Utils.getMovedLimitedValues(rot, self.Rot3.maxRot, self.Rot3.minRot, 3, self.Rot3.rotTime*2, dt, true);
			    setRotation(self.Rot3.node, unpack(newRot));
				local x, y, z = getRotation(self.Rot4.node);
		        local rot = {x,y,z};
		        local newRot = Utils.getMovedLimitedValues(rot, self.Rot4.maxRot, self.Rot4.minRot, 3, self.Rot4.rotTime*2, dt, true);
			    setRotation(self.Rot4.node, unpack(newRot));
				local x, y, z = getRotation(self.Rot5.node);
		        local rot = {x,y,z};
		        local newRot = Utils.getMovedLimitedValues(rot, self.Rot5.maxRot, self.Rot5.minRot, 3, self.Rot5.rotTime*2, dt, true);
			    setRotation(self.Rot5.node, unpack(newRot));
				local x, y, z = getRotation(self.Rot6.node);
		        local rot = {x,y,z};
		        local newRot = Utils.getMovedLimitedValues(rot, self.Rot6.maxRot, self.Rot6.minRot, 3, self.Rot6.rotTime*2, dt, true);
			    setRotation(self.Rot6.node, unpack(newRot));
				
				
				if not self.hydraOpenPlaying then
            			playSample(self.hydraOpenSoundId, 0, 1, 0);
            			self.hydraOpenPlaying = true;
        			end;
    			else
        			if self.hydraOpenPlaying then
            			stopSample(self.hydraOpenSoundId);
            			self.hydraOpenPlaying = false;
       			end;
			end;

			if Input.isKeyPressed(self.keys.CLOSE_PLIERS) and self.node2.baleId == nil and self.node3.baleId == nil then
				local x, y, z = getRotation(self.Rot1.node);
		        local rot = {x,y,z};
		        local newRot = Utils.getMovedLimitedValues(rot, self.Rot1.maxRot, self.Rot1.minRot, 3, self.Rot1.rotTime*2, dt, false);
			    setRotation(self.Rot1.node, unpack(newRot));
				local x, y, z = getRotation(self.Rot2.node);
		        local rot = {x,y,z};
		        local newRot = Utils.getMovedLimitedValues(rot, self.Rot2.maxRot, self.Rot2.minRot, 3, self.Rot2.rotTime*2, dt, false);
			    setRotation(self.Rot2.node, unpack(newRot));
				local x, y, z = getRotation(self.Rot3.node);
		        local rot = {x,y,z};
		        local newRot = Utils.getMovedLimitedValues(rot, self.Rot3.maxRot, self.Rot3.minRot, 3, self.Rot3.rotTime*2, dt, false);
			    setRotation(self.Rot3.node, unpack(newRot));
				local x, y, z = getRotation(self.Rot4.node);
		        local rot = {x,y,z};
		        local newRot = Utils.getMovedLimitedValues(rot, self.Rot4.maxRot, self.Rot4.minRot, 3, self.Rot4.rotTime*2, dt, false);
			    setRotation(self.Rot4.node, unpack(newRot));
				local x, y, z = getRotation(self.Rot5.node);
		        local rot = {x,y,z};
		        local newRot = Utils.getMovedLimitedValues(rot, self.Rot5.maxRot, self.Rot5.minRot, 3, self.Rot5.rotTime*2, dt, false);
			    setRotation(self.Rot5.node, unpack(newRot));
				local x, y, z = getRotation(self.Rot6.node);
		        local rot = {x,y,z};
		        local newRot = Utils.getMovedLimitedValues(rot, self.Rot6.maxRot, self.Rot6.minRot, 3, self.Rot6.rotTime*2, dt, false);
			    setRotation(self.Rot6.node, unpack(newRot));
				
				
				if not self.hydraClosePlaying then
            			playSample(self.hydraCloseSoundId, 0, 1, 0);
            			self.hydraClosePlaying = true;
        			end;
    			else
        			if self.hydraClosePlaying then
            			stopSample(self.hydraCloseSoundId);
            			self.hydraClosePlaying = false;
       			end;	

			end;				
	
	
	
	
			if self.node1.baleId == nil and self.node2.baleId == nil and self.node3.baleId == nil then
				if InputBinding.hasEvent(InputBinding.Toggle_Fork) then
					self:setFork(math.abs(self.forkId - 1), false);
				end;
			end;
			
			

			if self.forkId == 0 and self.node1.node ~= nil then
				if InputBinding.hasEvent(InputBinding.Toggle_Fork_Lock) then
					if self.lock.baleId == nil then
						
						if self:objectInRange(self.node1) ~= nil then 
							self.lock.node = self.node1.node;
							self.lock.child = getChildAt(self.lock.node, 0);
							local bale = self:objectInRange(self.node1);
							self:setBale(networkGetObjectId(bale), false);
							self.node1.baleId = self.lock.baleId;
						end;
						
					else
						self:setBale(nil, false);
						self.node1.baleId = nil;
					end;
				end;	
			end;
			if self.forkId == 1 and (self.node2.node ~= nil or self.node3.node ~= nil) then
				if InputBinding.hasEvent(InputBinding.Toggle_Fork_Lock) then
					if self:objectInRange(self.node2)~= nil or self:objectInRange(self.node3) ~= nil then
						if self:objectInRange(self.node2) ~= nil then
							self.lock.node = self.node2.node;
							self.lock.child = getChildAt(self.lock.node, 0);
							local bale = self:objectInRange(self.node2);
							self:setBale(networkGetObjectId(bale), false);
							self.node2.baleId = self.lock.baleId;
							self.lock.baleId = nil;
						end;
						if self:objectInRange(self.node3) ~= nil then
							self.lock.node = self.node3.node;
							self.lock.child = getChildAt(self.lock.node, 0);
							local bale = self:objectInRange(self.node3);
							self:setBale(networkGetObjectId(bale), false);
							self.node3.baleId = self.lock.baleId;
							self.lock.baleId = nil;
						end;
								
						if bale ~= nil then
							 self:setBale(networkGetObjectId(bale), false);
						end;
					else	
						if self.node2.baleId ~= nil and self.node3.baleId ~= nil then
							self.lock.baleId = self.node2.baleId;
							self.lock.child = getChildAt(self.lock.node, 0);
							self:setBale(nil, false);
							self.node2.baleId = nil;
							self.lock.baleId = self.node3.baleId;
							self.lock.child = getChildAt(self.lock.node, 0);
							self:setBale(nil, false);
							self.node3.baleId = nil;
						end;
						if	self.node2.baleId ~= nil and self:objectInRange(self.node3) == nil then
							self.lock.baleId = self.node2.baleId;
							self.lock.child = getChildAt(self.lock.node, 0);
							self:setBale(nil, false);
							self.node2.baleId = nil;
						end;
						if self.node3.baleId ~= nil and self:objectInRange(self.node2) == nil then
							self.lock.baleId = self.node3.baleId;
							self.lock.child = getChildAt(self.lock.node, 0);
							self:setBale(nil, false);
							self.node3.baleId = nil;
						end;
					end;
				end;
			end;
		end;
	end;
end;


function MchaleHandler:draw()
	if self.node1.baleId == nil and self.node2.baleId == nil and self.node3.baleId == nil then
		g_currentMission:addHelpButtonText(g_i18n:getText("Toggle_forks"), InputBinding.Toggle_Fork);
	end;

	if self.forkId == 0 and self.node1.node ~= nil then
		if self.lock.baleId ~= nil then
			g_currentMission:addHelpButtonText(g_i18n:getText("Toggle_Forks_Unlock"), InputBinding.Toggle_Fork_Lock);
		else
			if self:objectInRange(self.node1) ~= nil then
				g_currentMission:addHelpButtonText(g_i18n:getText("Toggle_Forks_Lock"), InputBinding.Toggle_Fork_Lock);
			end;
		end;
	end;
	
	if self.forkId == 1 and self.node2.node ~= nil and self.node3.node ~= nil then
		if self.node2.baleId ~= nil and self:objectInRange(self.node3) == nil then
			g_currentMission:addHelpButtonText(g_i18n:getText("Toggle_Forks_Unlock"), InputBinding.Toggle_Fork_Lock);
		else
			if self.node3.baleId ~= nil and self:objectInRange(self.node2) == nil then
				g_currentMission:addHelpButtonText(g_i18n:getText("Toggle_Forks_Unlock"), InputBinding.Toggle_Fork_Lock);
			else
				if self.node2.baleId ~= nil and self.node3.baleId ~= nil then
					g_currentMission:addHelpButtonText(g_i18n:getText("Toggle_Forks_Unlock_Both"), InputBinding.Toggle_Fork_Lock);
				else
					if self:objectInRange(self.node2) ~= nil or self:objectInRange(self.node3) ~= nil then
						g_currentMission:addHelpButtonText(g_i18n:getText("Toggle_Forks_Lock"), InputBinding.Toggle_Fork_Lock);
					end;
				end;
			end;
		end;
	end;
	
	if self.node1.baleId == nil then
		g_currentMission:addHelpButtonText(g_i18n:getText("OPEN_PLIERS"), InputBinding.OPEN_PLIERS);
	end;
	
	if self.node2.baleId == nil and self.node3.baleId == nil then
		g_currentMission:addHelpButtonText(g_i18n:getText("CLOSE_PLIERS"), InputBinding.CLOSE_PLIERS);
	end;
	
	
end;

function MchaleHandler:setFork(fork, noEventSend)
	MchaleHandlerEvent.sendEvent(self, fork, nil, noEventSend);

	setVisibility(self.fork1, fork == 0);
	setVisibility(self.fork2, fork == 1);
	setVisibility(self.fork3, fork == 0);
	setVisibility(self.fork4, fork == 1);
	self.forkId = fork;
end;

function MchaleHandler:setBale(baleId, noEventSend)
	if baleId ~= nil then
		if self.lock.child ~= nil then
			local bale = nil;

			if self.lock.baleId ~= nil then
				bale = networkGetObject(self.lock.baleId);
				if bale ~= nil then
					bale:unmount();
					self.lock.baleId = nil;
				end;
			end;

			MchaleHandlerEvent.sendEvent(self, self.forkId, baleId, noEventSend);

			bale = networkGetObject(baleId);
			if bale ~= nil then
				if getUserAttribute(bale.nodeId, "isRoundbale") then
					bale:mount(self, self.lock.child, 0,0,0, 0,0,0);
				end;

				self.lock.baleId = baleId;
			end;
		end;
	else
		MchaleHandlerEvent.sendEvent(self, self.forkId, baleId, noEventSend);

		if self.lock.baleId ~= nil then
			local bale = networkGetObject(self.lock.baleId);

			if bale ~= nil then
				bale:unmount();
				self.lock.baleId = nil;
			end;
		end;
	end;
end;

function MchaleHandler:objectInRange(refNode)
    local nearestDistance = 0.4;
    local nearestBale = nil;
    local px, py, pz = getWorldTranslation(refNode.node);

    for index, item in pairs(g_currentMission.itemsToSave) do
        if item.item:isa(Bale) or getUserAttribute(item.item.nodeId, "isStrawbale") or getUserAttribute(item.item.nodeId, "isHaybale") then
			local vx, vy, vz = getWorldTranslation(item.item.nodeId);
			local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
			if distance < nearestDistance then
				nearestDistance = distance;
				nearestBale = item.item;
			end;
        end;
    end;

    return nearestBale;
end;
