MchaleHandlerEvent = {};
MchaleHandlerEvent_mt = Class(MchaleHandlerEvent, Event);

InitEventClass(MchaleHandlerEvent, "MchaleHandlerEvent");

function MchaleHandlerEvent:emptyNew()
    local self = Event:new(MchaleHandlerEvent_mt);
    self.className="MchaleHandlerEvent";

    return self;
end;

function MchaleHandlerEvent:new(vehicle, fork, baleId)
    local self = MchaleHandlerEvent:emptyNew()
    self.vehicle = vehicle;
	self.fork = fork;
	self.baleId = baleId;

    return self;
end;

function MchaleHandlerEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);

    self.fork = streamReadInt8(streamId);
    self.baleId = streamReadInt32(streamId);

    self.vehicle = networkGetObject(id);

    self:run(connection);
end;

function MchaleHandlerEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.vehicle));

	streamWriteInt8(streamId, self.fork);
	streamWriteInt32(streamId, self.baleId);
end;

function MchaleHandlerEvent:run(connection)
	self.vehicle:setFork(self.fork, true);
	self.vehicle:setBale(self.baleId, true);

	if not connection:getIsServer() then
		g_server:broadcastEvent(MchaleHandlerEvent:new(self.vehicle, self.fork, self.baleId), nil, connection, self.object);
	end;
end;

function MchaleHandlerEvent.sendEvent(vehicle, fork, baleId, noEventSend)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(MchaleHandlerEvent:new(vehicle, fork, baleId), nil, nil, vehicle);
		else
			g_client:getServerConnection():sendEvent(MchaleHandlerEvent:new(vehicle, fork, baleId));
		end;
	end;
end;